$!-----------------------------------------------------------------------------
$! BUILD_OSU.COM
$! Builds the OSU example scripts for both VAX and AXP systems (separately)
$!
$! P1 == BUILD or LINK
$! P1 == "DELETE" deletes those scripts from HT_EXE ;^)
$!
$! 07-JAN-98  MGD  initial development
$!-----------------------------------------------------------------------------
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""OSU""" +-
                   " for ""''F$GETSYI("ARCH_NAME")'"" architecture"
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE /DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ DEFINES = "/DEFINE=(_VMS_V6_SOURCE=1,__VMS_VER=60000000,__CRTL_VER=60000000)"
$ IF F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") .EQS. "VAX"
$ THEN
$    CC_OPTIONS = "/STANDARD=VAXC 'DEFINES' /OBJECT=''OBJECT_DIR'"
$ ELSE
$    CC_OPTIONS = "/STANDARD=VAXC 'DEFINES' /OBJECT=''OBJECT_DIR'"
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD"
$ THEN
$    SET NOON
$    SET VERIFY
$!
$!   (support modules)
$    CC 'CC_OPTIONS' CGILIB.C
$    CC 'CC_OPTIONS' LBRIO.C
$    CC 'CC_OPTIONS' SCRIPTLIB.C
$!
$!   (various executables)
$    CC 'CC_OPTIONS' CGI_SYMBOLS.C
$    CC 'CC_OPTIONS' CGI-MAILTO.C
$    CC 'CC_OPTIONS' SET_DCL_ENV.C
$    CC 'CC_OPTIONS' TESTCGI.C
$    CC 'CC_OPTIONS' TESTFORM.C
$    CC 'CC_OPTIONS' TMAIL.C
$    CC 'CC_OPTIONS' VMSHELPGATE.C
$!
$!   (bookreader application)
$    CC 'CC_OPTIONS' WEBBOOK.C
$    CC 'CC_OPTIONS' BOOKFILE_SECTION.C
$    CC 'CC_OPTIONS' BOOKFILE_INDEX.C
$    CC 'CC_OPTIONS' BOOKFILE_TEXT.C
$    CC 'CC_OPTIONS' BOOKFILE_IO.C
$    CC 'CC_OPTIONS' BOOKFILE_FIGURE.C
$    CC 'CC_OPTIONS' WEBBOOK_SHELF.C
$!
$!   (HTML pre-processor)
$    CC 'CC_OPTIONS' ACCESS_DB.C
$    CC 'CC_OPTIONS' HTML_PREPROC.C
$!
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "LINK"
$ THEN
$    SET NOON
$    SET VERIFY
$    LINK /EXECUTABLE=HT_EXE:CGI_SYMBOLS.EXE -
          'OBJECT_DIR'CGI_SYMBOLS, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=HT_EXE:CGI-MAILTO.EXE -
          'OBJECT_DIR'CGI-MAILTO, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=HT_EXE:HTML_PREPROC.EXE -
          'OBJECT_DIR'HTML_PREPROC, -
          'OBJECT_DIR'ACCESS_DB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=HT_EXE:SET_DCL_ENV.EXE -
          'OBJECT_DIR'SET_DCL_ENV, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    COPY DCL_ENV_RM.COM HT_EXE:
$    LINK /EXECUTABLE=HT_EXE:OSU_TESTCGI.EXE -
          'OBJECT_DIR'TESTCGI, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=HT_EXE:OSU_TESTFORM.EXE -
          'OBJECT_DIR'TESTFORM, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=HT_EXE:TMAIL.EXE -
          'OBJECT_DIR'TMAIL, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=HT_EXE:VMSHELPGATE.EXE -
          'OBJECT_DIR'VMSHELPGATE, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'LBRIO, -
          'OBJECT_DIR'SCRIPTLIB
$    COPY HELPGATE.COM HT_EXE:
$!
$    LINK /EXECUTABLE=HT_EXE:WEBBOOK.EXE WEBBOOK_'ARCH_NAME'.OPT/OPTION
$!
$    COPY WWWEXEC.COM HT_EXE:
$    COPY CGIWASD.COM HT_EXE:
$!
$!   'F$VERIFY(0)
$    SET ON
$    SET PROTECTION=W:RE HT_EXE:CGI_SYMBOLS.EXE
$    SET PROTECTION=W:RE HT_EXE:HTML_PREPROC.EXE
$    SET PROTECTION=W:RE HT_EXE:SET_DCL_ENV.EXE
$    SET PROTECTION=W:RE HT_EXE:DCL_ENV_RM.COM
$    SET PROTECTION=W:RE HT_EXE:OSU_TESTCGI.EXE
$    SET PROTECTION=W:RE HT_EXE:OSU_TESTFORM.EXE
$    SET PROTECTION=W:RE HT_EXE:TMAIL.EXE
$    SET PROTECTION=W:RE HT_EXE:VMSHELPGATE.EXE
$    SET PROTECTION=W:RE HT_EXE:HELPGATE.COM
$    SET PROTECTION=W:RE HT_EXE:WEBBOOK.EXE
$    SET PROTECTION=W:RE HT_EXE:WWWEXEC.COM
$    SET PROTECTION=W:RE HT_EXE:CGIWASD.COM
$    PURGE /NOLOG 'OBJECT_DIR'
$ ENDIF
$!
$ IF P1 .EQS. "DELETE"
$ THEN
$    SET NOON
$    SET VERIFY
$    DELETE HT_EXE:HTML_PREPROC.EXE;*
$    DELETE HT_EXE:SET_DCL_ENV.EXE;*
$    DELETE HT_EXE:DCL_ENV_RM.COM;*
$    DELETE HT_EXE:OSU_TESTCGI.EXE;*
$    DELETE HT_EXE:OSU_TESTFORM.EXE;*
$    DELETE HT_EXE:TMAIL.EXE;*
$    DELETE HT_EXE:VMSHELPGATE.EXE;*
$    DELETE HT_EXE:HELPGATE.COM;*
$    DELETE HT_EXE:WEBBOOK.EXE;*
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$!-----------------------------------------------------------------------------
